#
#  
#
proc do_tens {} {
    global prompt
    global numbers
    global len
    global gender

    if {$numbers(tens) != 0} {
	if {[string length $numbers(tens)] == 1} {
	    switch -regexp $numbers(tens) {
	    {0} { }
	    {1-2} {
		    lappend prompt "ru_$numbers(tens)_[set gender].au"
		}
	    default {
		    lappend prompt "ru_$numbers(tens).au"
		}
	    }
	} {
	    #   
	    set seperate [split $numbers(tens) {}]
	    switch -regexp $numbers(tens) {
	    {00} { }
	    {[0][1-2]} {
		    lappend prompt "ru_[lindex $seperate 1]_[set gender].au"
		}
	    {[0][3-9]} {
		    lappend prompt "ru_[lindex $seperate 1].au"
		}
	    {[1][1-9]} {
		    lappend prompt "ru_$numbers(tens).au"
		}
	    {[2-9][1-2]} {
		    lappend prompt "ru_$numbers(tens)_[set gender].au"
		}
	    {[1-9][0]} {
		    lappend prompt "ru_[lindex $seperate 0]0.au"
		}
	    default {
		    lappend prompt "ru_[lindex $seperate 0]0.au" "ru_[lindex $seperate 1].au"
		}
	    }
	}
    }

    return 0
}

#
#  
#
proc do_hundreds {} {
    global prompt
    global numbers

    if {$numbers(hundreds) == 0} {
	return 0
    } {
	lappend prompt "ru_$numbers(hundreds)00.au"
    }
    return 0
}

#
#  
#
proc do_thousands {} {
    global prompt
    global numbers
    global len

    if {$numbers(thousands) == 0} {
	lappend prompt "ru_5-20_thousand.au"
    } {
	if {$len == 4} {
	    switch -regexp $numbers(thousands) {
	    {1} {
		    lappend prompt "ru_thousand.au"
		}
	    {2} {
		    lappend prompt "ru_$numbers(thousands)_f.au" "ru_2-4_thousand.au"
		}
	    {[3-4]} {
		    lappend prompt "ru_$numbers(thousands).au" "ru_2-4_thousand.au"
		}
	    default {
		    lappend prompt "ru_$numbers(thousands).au" "ru_5-20_thousand.au"
		}
	    }
	} {
	    set seperate [split $numbers(thousands) {}]
	    switch -regexp $numbers(thousands) {
	    {00} {
		    lappend prompt "ru_5-20_thousand.au"
		}
	    {01} {
		    lappend prompt "ru_thousand.au"
		}
	    {02} {
		    lappend prompt "ru_[lindex $seperate 1]_f.au" "ru_2-4_thousand.au"
		}
	    {[0][3-4]} {
		    lappend prompt "ru_[lindex $seperate 1].au" "ru_2-4_thousand.au"
		}
	    {[0][5-9]} {
		    lappend prompt "ru_[lindex $seperate 1].au" "ru_5-20_thousand.au"
		}
	    {[1-9][0]} {
		    lappend prompt "ru_[lindex $seperate 0]0.au" "ru_5-20_thousand.au"
		}
	    {[1][1-9]} {
		    lappend prompt "ru_$numbers(thousands).au" "ru_5-20_thousand.au"
		}
	    {[2-9][1]} {
		    lappend prompt "ru_$numbers(thousands)_f.au" "ru_thousand.au"
		}
	    {[2-9][2]} {
		    lappend prompt "ru_$numbers(thousands)_f.au" "ru_2-4_thousand.au"
		}
	    {[2-9][3-4]} {
		    lappend prompt "ru_[lindex $seperate 0]0.au" "ru_[lindex $seperate 1].au" "ru_2-4_thousand.au"
		}
	    {[2-9][5-9]} {
		    lappend prompt "ru_[lindex $seperate 0]0.au" "ru_[lindex $seperate 1].au" "ru_5-20_thousand.au"
		}
	    }
	}
    }

    return 0
}

#
#   
#
proc do_hthousands {} {
    global prompt
    global numbers

    lappend prompt "ru_$numbers(hthousands)00.au"

    return 0
}

#
#    
#
proc do_whole_part {} {
    global prompt
    global numbers
    global len
    global newlist

    #   numbers
    set numbers(tens) {}
    set numbers(hundreds) {}
    set numbers(thousands) {}
    set numbers(hthousands) {}

    # len =       newlist
    set len [string length [lindex $newlist 0]]

    #      
    set seperate [split [lindex $newlist 0] {}]

    #    numbers
    switch $len {
    {1} {
	    set numbers(tens) [lindex $seperate 0]
	}
    {2} {
	    set numbers(tens) [join [list [lindex $seperate 0] [lindex $seperate 1]] {}]
	}
    {3} {
	    set numbers(hundreds) [lindex $seperate 0]
	    set numbers(tens) [join [list [lindex $seperate 1] [lindex $seperate 2]] {}]
	}
    {4} {
	    set numbers(thousands) [lindex $seperate 0]
	    set numbers(hundreds) [lindex $seperate 1]
	    set numbers(tens) [join [list [lindex $seperate 2] [lindex $seperate 3]] {}]
	}
    {5} {
	    set numbers(thousands) [join [list [lindex $seperate 0] [lindex $seperate 1]] {}]
	    set numbers(hundreds) [lindex $seperate 2]
	    set numbers(tens) [join [list [lindex $seperate 3] [lindex $seperate 4]] {}]
	}
    {6} {
	    set numbers(hthousands) [lindex $seperate 0]
	    set numbers(thousands) [join [list [lindex $seperate 1] [lindex $seperate 2]] {}]
	    set numbers(hundreds) [lindex $seperate 3]
	    set numbers(tens) [join [list [lindex $seperate 4] [lindex $seperate 5]] {}]
	}
    }

    #     numbers,   prompt
    foreach index {hthousands thousands hundreds tens} {
	if {$numbers($index) != ""} {
	    do_$index
	}
    }
    return 0
}

#
#     (  )
#
proc do_decimal_part {} {
    global newlist
    global prompt
    global gender

    #      ,    ,   ""
    if {([lindex $newlist 0] > 0) &&([lindex $newlist 1] > 0)} {
	lappend prompt "ru_and.au"
    }

    #   

    if {[string length [lindex $newlist 1]] == 1} {
	#      ,   
	# ,   ..
	switch -regexp [lindex $newlist 1] {
	{0} { }
	default {
		lappend prompt "ru_[lindex $newlist 1]0.au"
	    }
	}
    } {
	#     -      

	#     
	set seperate [split [lindex $newlist 1] {}]
	switch -regexp [lindex $newlist 1] {
	{00} { }
	{[0][1-2]} {
		lappend prompt "ru_[lindex $seperate 1]_[set gender].au"
	    }
	{[0][3-9]} {
		lappend prompt "ru_[lindex $seperate 1].au"
	    }
	{[1][1-9]} {
		lappend prompt "ru_[lindex $newlist 1].au"
	    }
	{[2-9][1-2]} {
		lappend prompt "ru_[lindex $newlist 1]_[set gender].au"
	    }
	{[1-9][0]} {
		lappend prompt "ru_[lindex $seperate 0]0.au"
	    }
	default {
		lappend prompt "ru_[lindex $seperate 0]0.au" "ru_[lindex $seperate 1].au"
	    }
	}
    }
    return 0
}

#
#  
#
proc do_welcome {} {
    global state
    global pr_no_input

    set ev [playPrompt pr_no_input info ru_welcome.au]
    set state do_get_card_number

    return 0
}

#
#  - ( .     )
#
proc do_get_card_number {} {
    global state
    global account
    global pin

    set account {}
    set pin {}
    set state do_first_authorize

    return 0
}

#
#   -   (-)
#
proc do_first_authorize {} {
    global state
    global pin
    global account
    global retry_count
    global pr_no_input
    global amt
    global returncode
    global minus
    global zero

    set ev [authorize $account $pin {} [ani] info]

    if {[getVariable aaa h323-return-code info] != 0} {
	puts "\t\t**** got h323-return-code: $info(0)"
	set returncode $info(0)
    } {
	puts "\t\t**** can't get h323-return-code"
	set returncode 255
	set ev [playPrompt pr_no_input info ru_no_service.au]
	set state end
	return 0
    }

    switch -regexp $ev {
    {authorized} {
	    if {[getVariable aaa h323-credit-amount info] != 0} {
		puts "\t\t**** got h323-credit-amount: $info(0)"
		set amt $info(0)
		if {$amt < $zero} {
		    set minus 1
		}
		set amt [expr {$amt - $zero}]
		set amt [expr abs($amt)]
		set state do_get_dest
	    } {
		puts "\t\t**** can't get h323-credit-amount"
		set ev [playPrompt pr_no_input info ru_no_service.au]
		set state end
	    }
	}
    {authorization failed} {
	    # play prompt based on return code
	    switch $returncode {
	    # TARIFF_NOT_FOUND
	    {3} {
		    set ev [playPrompt pr_no_input info ru_no_service.au]
		    set state do_first_authorize_fail
		}
	    # BALANCE_ON_ZERO
	    {4} {
		    set ev [playPrompt pr_no_input info ru_not_enuf.au]
		    set state do_first_authorize_fail
		}
	    # TOO_MANY_SESSIONS
	    {5} {
		    set ev [playPrompt pr_no_input info ru_final.au]
		    set state do_first_authorize_fail
		}
	    # SID_NOT_FOUND
	    {7} {
		    set ev [playPrompt pr_no_input info ru_no_service.au]
		    set state do_first_authorize_fail
		}
	    # CARD_EXPIRED
	    {8} {
		    set ev [playPrompt pr_no_input info ru_card_expired.au]
		    set state do_first_authorize_fail
		}
	    # CARD_LOCK
	    {9} {
		    set ev [playPrompt pr_no_input info ru_no_service.au]
		    set state do_first_authorize_fail
		}
	    # PRICE_NOT_FOUND
	    {11} {
		    set ev [playPrompt pr_no_input info ru_dest_blocked.au]
		    set state do_first_authorize_fail
		}
	    # SET_CONNECTION_ERROR
	    {12} {
		    set ev [playPrompt pr_no_input info ru_dest_unreachable.au]
		    set state do_first_authorize_fail
		}
	    # CONTRACT_NOT_FOUND_ERROR
	    {14} {
		    set ev [playPrompt pr_no_input info ru_no_service.au]
		    set state do_first_authorize_fail
		}
	    # NOT_MONEY_FOR_THIS_CALL
	    {15} {
		    set ev [playPrompt pr_no_input info ru_not_enuf.au]
		    set state do_first_authorize_fail
		}
	    {"Unknown variable name"} {
		    set ev [playPrompt pr_no_input info ru_technical_problem.au]
		    set state do_first_authorize_fail
		}
	    }

	}
    default {
	    set ev [playPrompt pr_no_input info ru_technical_problem.au]
	    set state end
	}
    }
    return 0
}

#
#    
#
proc do_get_dest {} {
    global state
    global destination
    global retry_count
    global second_auth_failure_code
    global second_auth_failure_counter
    global dest_failure_code
    global pr_input
    global amt
    global prompt
    global len
    global newlist
    global gender
    global numbers
    global minus
    global already_played

    switch -regexp $second_auth_failure_code {
    {0} {
	    if {$already_played == 0} {
		set already_played 1
		set prompt ""

		if {$minus} {
		    lappend prompt "ru_minus.au"
		}

		set newlist [split $amt .]
		set gender m
		do_whole_part

		if {$len == 1} {
		    switch -regexp $numbers(tens) {
		    {0} { }
		    {1} {
			    lappend prompt "ru_dollar.au"
			}
		    {[2-4]} {
			    lappend prompt "ru_2-4_dollars.au"
			}
		    {[5-9]} {
			    lappend prompt "ru_5-20_dollars.au"
			}
		    }
		} {
		    switch -regexp $numbers(tens) {
		    {[0-9]*[0|2-9][2-4]} {
			    lappend prompt "ru_2-4_dollars.au"
			}
		    {[0-9]*[2-9][1]} {
			    lappend prompt "ru_dollar.au"
			}
		    default {
			    lappend prompt "ru_5-20_dollars.au"
			}
		    }
		}

		set gender f
		do_decimal_part

		if {[string length [lindex $newlist 1]] == 1} {
		    switch -regexp [lindex $newlist 1] {
		    {0} { }
		    {1} {
			    lappend prompt "ru_cent.au"
			}
		    {[2-4]} {
			    lappend prompt "ru_2-4_cents.au"
			}
		    default {
			    lappend prompt "ru_5-20_cents.au"
			}
		    }
		} {
		    switch -regexp [lindex $newlist 1] {
		    {00} { }
		    {[0|2-9][1]} {
			    lappend prompt "ru_cent.au"
			}
		    {[0|2-9][2-4]} {
			    lappend prompt "ru_2-4_cents.au"
			}
		    default {
			    lappend prompt "ru_5-20_cents.au"
			}
		    }
		}

		puts "\t\t**** playPrompt pr_input info ru_you_have.au $prompt"
		set ev [eval [list playPrompt pr_input info ru_you_have.au] $prompt "%s1000 ru_enter_dest.au"]
	    } {
		puts "\t\t**** playPrompt pr_input info ru_enter_dest.au"
		set ev [playPrompt pr_input info ru_enter_dest.au]
	    }
	}
    {1} {
	    set ev [playPrompt pr_input info ru_reenter_dest.au]
	}
    {2} {
	    set ev [playPrompt pr_input info ru_author_fail.au]
	}
    {3} {
	    set ev [playPrompt pr_input info ru_no_dest_entered.au]
	}
    }

    switch -regexp $ev {
    {collect success} {
	    set destination $info(digits)
	    set state do_second_authorize
	}
    {collect aborted} {
	    set state do_get_dest
	}
    {collect fail} {
	    incr second_auth_failure_counter
	    set second_auth_failure_code 1
	    if {$second_auth_failure_counter < $retry_count} {
		set state do_get_dest
	    } {
		set state do_collect_fail
	    }
	}
    {collect timeout} {
	    incr second_auth_failure_counter
	    set second_auth_failure_code 3
	    if {$second_auth_failure_counter < $retry_count} {
		set state do_get_dest
	    } {
		set state do_collect_fail
	    }
	}
    default {
	    set state end
	}
    }
    return 0
}

#
#   .     .
#
proc do_second_authorize {} {
    global state
    global destination
    global last_destination
    global account
    global pin
    global creditTime
    global warnTime
    global second_auth_failure_code
    global second_auth_failure_counter
    global retry_count
    global pr_no_input
    global no_time_limit
    global len
    global prompt
    global newlist
    global returncode

    # strip out all before first '7' or '8'
    regsub {^[^78]*([78][0-9]*)} $destination {\1} destination

    switch -regexp $destination {
    {^[78]2[0-9][0-9][0-9][0-9][0-9][0-9][0-9]$} {
	    set destination 7347[string range $destination 2 end]
	}
    {^810[0-9]+$} {
	    set destination 6666#[string range $destination 3 end]
	}
    {^81[0-9]+$} {
	    set destination 6666#[string range $destination 2 end]
	}
    {^[78][0-9]+$} {
	    set destination 6767#7[string range $destination 1 end]
	}
    {^2$} {
	    set destination $last_destination
	}
    {^33$} {
	    incr second_auth_failure_counter
	    set second_auth_failure_code 0
	    if {$second_auth_failure_counter < $retry_count} {
		set state do_get_dest
	    } {
		set state do_second_authorize_fail
	    }
	    return 0
	}
    default { }
    }

    set last_destination $destination

    #   
    set ev [authorize $account $pin $destination [ani] info]

    if {[getVariable aaa h323-return-code info] != 0} {
	puts "\t\t**** got h323-return-code: $info(0)"
	set returncode $info(0)
    } {
	puts "\t\t**** can't get h323-return-code"
	set returncode 255
	set ev [playPrompt pr_no_input info ru_no_service.au]
	set state end
	return 0
    }

    switch -regexp $ev {
    {authorized} {
	    if {[getVariable aaa h323-credit-time info] != 0} {
		puts "\t\t**** got h323-credit-time: $info(0)"
		set creditTime $info(0)
	    } {
		puts "\t\t**** can't get h323-credit-amount"
		set creditTime "uninitialized"
	    }

	    if {$creditTime == "uninitialized"} {
		set ev [playPrompt pr_no_input info ru_technical_problem.au]
		set state end
	    } elseif {$creditTime == "unlimited"} {
		set no_time_limit 1
		set state do_place_call
	    } {
		set state do_place_call
	    }
	}
    {authorization failed} {
	    puts "\t\t**** got return code: $returncode"

	    # play prompt based on return code
	    switch $returncode {
	    # TARIFF_NOT_FOUND
	    {3} {
		    set ev [playPrompt pr_no_input info ru_no_service.au]
		}
	    # BALANCE_ON_ZERO
	    {4} {
		    set ev [playPrompt pr_no_input info ru_not_enuf.au]
		    set state end
		    return 0
		}
	    # TOO_MANY_SESSIONS
	    {5} {
		    set ev [playPrompt pr_no_input info ru_final.au]
		}
	    # SID_NOT_FOUND
	    {7} {
		    set ev [playPrompt pr_no_input info ru_no_service.au]
		}
	    # CARD_EXPIRED
	    {8} {
		    set ev [playPrompt pr_no_input info ru_card_expired.au]
		}
	    # CARD_LOCK
	    {9} {
		    set ev [playPrompt pr_no_input info ru_no_service.au]
		}
	    # PRICE_NOT_FOUND
	    {11} {
		    set ev [playPrompt pr_no_input info ru_dest_blocked.au]
		}
	    # SET_CONNECTION_ERROR
	    {12} {
		    set ev [playPrompt pr_no_input info ru_dest_unreachable.au]
		}
	    # NOT_MONEY_FOR_THIS_CALL
	    {15} {
		    set ev [playPrompt pr_no_input info ru_not_enuf.au]
		}
	    {"Unknown variable name"} {
		    set ev [playPrompt pr_no_input info ru_technical_problem.au]
		}
	    }

	    incr second_auth_failure_counter
	    set second_auth_failure_code 2
	    if {$second_auth_failure_counter < $retry_count} {
		set state do_get_dest
	    } {
		set state do_second_authorize_fail
	    }
	}
    default {
	    set state end
	}
    }
    return 0
}

#
# 
#
proc do_place_call {} {
    global state
    global destination
    global account
    global second_auth_failure_counter
    global second_auth_failure_code

    set second_auth_failure_counter 0
    set second_auth_failure_code 0
    set callInfo(accountNum) $account

    set ev [placeCall $destination callInfo info]

    switch -regexp $ev {
    {active} {
	    set state do_active
	}
    {call fail} {
	    set state do_place_fail
	}
    default {
	    set state end
	}
    }
    return 0
}

#
#  (  )
#
proc do_active_notimer {} {
    global state

    set ev [waitEvent]

    while {$ev == "digit"} {
	set ev [waitEvent]
    }
    set state end
    return 0
}

#
#  ( ,   )
#
proc do_active_last_timer {} {
    global state
    global warnTime
    global creditTime
    global no_play

    if {$no_play == 1} {
	set ev [startTimer [expr {$creditTime - 1}] info]
    } {
	set ev [startTimer [expr {$warnTime - 4}] info]
    }

    while {$ev == "digit"} {
	set ev [startTimer $info(timeLeft) info]
    }

    switch -regexp $ev {
    {longpound} {
	    set state do_longpound
	    return 0
	}
    {timeout} {
	    clearOutgoingLeg info
	    set state do_out_of_time
	}
    default {
	    set state end
	}
    }
    return 0
}

#
#  longpound'
#
proc do_longpound {} {
    global state
    global no_play
    global pr_no_input

    set no_play 0

    clearOutgoingLeg info
    set ev [playPrompt pr_no_input info ru_disconnect.au]
    set state do_get_dest
    return 0
}

#
#     
#
proc do_active_timer {} {
    global state
    global warnTime
    global creditTime
    global no_play
    global pr_no_input

    set delay [expr {$creditTime - $warnTime}]
    set ev [startTimer $delay info]

    while {$ev == "digit"} {
	set ev [startTimer $info(timeLeft) info]
    }

    switch -regexp $ev {
    {longpound} {
	    set state do_longpound
	    return 0
	}
    {outgoing disconnected} {
#	    set ev [playPrompt pr_no_input info ru_disconnect.au]
	    set state do_get_dest
	}
    {timeout} {
	    if {$no_play != 1} {
		set warnTime [string trimleft $warnTime]
		set ev [playPrompt pr_no_input info ru_you_have.au ru_$warnTime.au ru_seconds.au]
	    }
	    set state do_active_last_timer
	}
    default {
	    set state end
	}
    }
    return 0
}

#
# 
#
proc do_active {} {
    global state
    global creditTime
    global warnTime
    global no_time_limit

    if {($no_time_limit == 1) ||($creditTime == "unlimited") ||($creditTime == "uninitialized")} {
	set state do_active_notimer
    } {
	if {$creditTime < $warnTime} {
	    set state do_active_last_timer
	} {
	    set state do_active_timer
	}
    }
    return 0
}

#
#    
#
proc do_out_of_time {} {
    global state
    global pr_no_input

    set ev [playPrompt pr_no_input info ru_disconnect.au]
    set state end
    return 0
}

#
#  
#
proc do_first_authorize_fail {} {
    global state
    global pr_no_input

    set ev [playPrompt pr_no_input info ru_final.au]
    set state end
    return 0
}

#
#   
#
proc do_second_authorize_fail {} {
    global state
    global pr_no_input

    set ev [playPrompt pr_no_input info ru_final.au]
    set state end
    return 0
}

#
# "    ..."
#
proc do_collect_fail {} {
    global state
    global pr_no_input

    set ev [playPrompt pr_no_input info ru_dest_collect_fail.au]
    set state end
    return 0
}

#
#   
#
proc do_place_fail {} {
    global state
    global pr_no_input


    set ev [failureCode info]

    if {$ev == "call fail"} {
	puts "\t\t**** got failure code: $info(code)"
	switch $info(code) {
	{1} -
	{2} -
	{3} {
		set ev [playPrompt pr_no_input info "ru_dc01.au %s1000"]
	    }
	{17} {
		set ev [playPrompt pr_no_input info "ru_dc11.au %s1000"]
	    }
	{19} {
		set ev [playPrompt pr_no_input info "ru_dc13.au %s1000"]
	    }
	{21} {
		set ev [playPrompt pr_no_input info "ru_dc15.au %s1000"]
	    }
	{22} {
		set ev [playPrompt pr_no_input info "ru_dc16.au %s1000"]
	    }
	{28} {
		set ev [playPrompt pr_no_input info "ru_dc1c.au %s1000"]
	    }
	{34} {
		set ev [playPrompt pr_no_input info "ru_dc22.au %s1000"]
	    }
	{41} {
		set ev [playPrompt pr_no_input info "ru_dc29.au %s1000"]
	    }
	default {
		set ev [playPrompt pr_no_input info "ru_error.au %s1000"]
	    }
	}
    }

    set state do_get_dest

    return 0
}

#-------------------------------------------------------
# main
#

acceptCall

# set primary language
setVariable language 1

# set "longpound" feature
setVariable longPound true

set second_auth_failure_code 0
set second_auth_failure_counter 0
set no_play 0
set dest_failure_code 0
set no_time_limit 0
set destination 0900405
set last_destination $destination
set zero 100000
set uid_len [getVariable config uidLen]
set pin_len [getVariable config pinLen]
set minus 0
set already_played 0

# collect digits, may be interrupted, used for collect pin-code
set pr_input_pin(interrupt) true
set pr_input_pin(abortKey) *
set pr_input_pin(terminationKey) #
set pr_input_pin(maxDigits) [expr {$uid_len + $pin_len}]

# doesn't collect digits, may be interrupted
set pr_no_input(interrupt) true
set pr_no_input(abortKey) *
set pr_no_input(terminationKey) #
set pr_no_input(playComplete) true

# collect digits, use dial plan, may be interrupted
set pr_input(interrupt) true
set pr_input(abortKey) *
set pr_input(terminationKey) #
set pr_input(dialPlanTerm) true

# get global configuration parameters from AS5xxx
set retry_count [getVariable config retryCount]
set warnTime [getVariable config warningTime]

set state do_welcome

while {$state != "end"} {
    puts "************ cid([callID]) app running state $state"
    $state
}

